Index: uspace/lib/usb/src/hub.c
===================================================================
--- uspace/lib/usb/src/hub.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/src/hub.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -40,10 +40,4 @@
 #include <errno.h>
 #include <assert.h>
-#include <usb/debug.h>
-
-/** How much time to wait between attempts to register endpoint 0:0.
- * The value is based on typical value for port reset + some overhead.
- */
-#define ENDPOINT_0_0_REGISTER_ATTEMPT_DELAY_USEC (1000 * (10 + 2))
 
 /** Check that HC connection is alright.
@@ -59,4 +53,35 @@
 	} while (false)
 
+
+/** Tell host controller to reserve default address.
+ *
+ * @param connection Opened connection to host controller.
+ * @param speed Speed of the device that will respond on the default address.
+ * @return Error code.
+ */
+int usb_hc_reserve_default_address(usb_hc_connection_t *connection,
+    usb_speed_t speed)
+{
+	CHECK_CONNECTION(connection);
+
+	return async_req_2_0(connection->hc_phone,
+	    DEV_IFACE_ID(USBHC_DEV_IFACE),
+	    IPC_M_USBHC_RESERVE_DEFAULT_ADDRESS, speed);
+}
+
+/** Tell host controller to release default address.
+ *
+ * @param connection Opened connection to host controller.
+ * @return Error code.
+ */
+int usb_hc_release_default_address(usb_hc_connection_t *connection)
+{
+	CHECK_CONNECTION(connection);
+
+	return async_req_1_0(connection->hc_phone,
+	    DEV_IFACE_ID(USBHC_DEV_IFACE),
+	    IPC_M_USBHC_RELEASE_DEFAULT_ADDRESS);
+}
+
 /** Ask host controller for free address assignment.
  *
@@ -153,11 +178,6 @@
  * error codes than those listed as return codes by this function itself).
  *
- * The @p connection representing connection with host controller does not
- * need to be started.
- * This function duplicates the connection to allow simultaneous calls of
- * this function (i.e. from different fibrils).
- *
  * @param[in] parent Parent device (i.e. the hub device).
- * @param[in] connection Connection to host controller.
+ * @param[in] connection Opened connection to host controller.
  * @param[in] dev_speed New device speed.
  * @param[in] enable_port Function for enabling signaling through the port the
@@ -186,40 +206,43 @@
     ddf_dev_ops_t *dev_ops, void *new_dev_data, ddf_fun_t **new_fun)
 {
-	assert(connection != NULL);
-	// FIXME: this is awful, we are accessing directly the structure.
-	usb_hc_connection_t hc_conn = {
-		.hc_handle = connection->hc_handle,
-		.hc_phone = -1
-	};
+	CHECK_CONNECTION(connection);
+
+	/*
+	 * Request new address.
+	 */
+	usb_address_t dev_addr = usb_hc_request_address(connection, dev_speed);
+	if (dev_addr < 0) {
+		return EADDRNOTAVAIL;
+	}
 
 	int rc;
 
-	rc = usb_hc_connection_open(&hc_conn);
-	if (rc != EOK) {
-		return rc;
-	}
-
-
-	/*
-	 * Request new address.
-	 */
-	usb_address_t dev_addr = usb_hc_request_address(&hc_conn, dev_speed);
-	if (dev_addr < 0) {
-		usb_hc_connection_close(&hc_conn);
-		return EADDRNOTAVAIL;
-	}
-
-	/*
-	 * We will not register control pipe on default address.
-	 * The registration might fail. That means that someone else already
-	 * registered that endpoint. We will simply wait and try again.
-	 * (Someone else already wants to add a new device.)
+	/*
+	 * Reserve the default address.
+	 */
+	rc = usb_hc_reserve_default_address(connection, dev_speed);
+	if (rc != EOK) {
+		rc = EBUSY;
+		goto leave_release_free_address;
+	}
+
+	/*
+	 * Enable the port (i.e. allow signaling through this port).
+	 */
+	rc = enable_port(port_no, arg);
+	if (rc != EOK) {
+		goto leave_release_default_address;
+	}
+
+	/*
+	 * Change the address from default to the free one.
+	 * We need to create a new control pipe for that.
 	 */
 	usb_device_connection_t dev_conn;
 	rc = usb_device_connection_initialize_on_default_address(&dev_conn,
-	    &hc_conn);
+	    connection);
 	if (rc != EOK) {
 		rc = ENOTCONN;
-		goto leave_release_free_address;
+		goto leave_release_default_address;
 	}
 
@@ -229,50 +252,54 @@
 	if (rc != EOK) {
 		rc = ENOTCONN;
-		goto leave_release_free_address;
-	}
-
-	do {
-		rc = usb_pipe_register_with_speed(&ctrl_pipe, dev_speed, 0,
-		    &hc_conn);
-		if (rc != EOK) {
-			/* Do not overheat the CPU ;-). */
-			async_usleep(ENDPOINT_0_0_REGISTER_ATTEMPT_DELAY_USEC);
-		}
-	} while (rc != EOK);
-
-	/*
-	 * Endpoint is registered. We can enable the port and change
-	 * device address.
-	 */
-	rc = enable_port(port_no, arg);
-	if (rc != EOK) {
-		goto leave_release_default_address;
-	}
-
+		goto leave_release_default_address;
+	}
+
+	/* Before sending any traffic, we need to register this
+	 * endpoint.
+	 */
+	rc = usb_pipe_register(&ctrl_pipe, 0, connection);
+	if (rc != EOK) {
+		rc = EREFUSED;
+		goto leave_release_default_address;
+	}
 	rc = usb_pipe_probe_default_control(&ctrl_pipe);
 	if (rc != EOK) {
+		rc = ENOTCONN;
+		goto leave_release_default_address;
+	}
+
+	rc = usb_pipe_start_session(&ctrl_pipe);
+	if (rc != EOK) {
+		rc = ENOTCONN;
+		goto leave_unregister_endpoint;
+	}
+
+	rc = usb_request_set_address(&ctrl_pipe, dev_addr);
+	if (rc != EOK) {
 		rc = ESTALL;
-		goto leave_release_default_address;
-	}
-
-	rc = usb_request_set_address(&ctrl_pipe, dev_addr);
-	if (rc != EOK) {
-		rc = ESTALL;
-		goto leave_release_default_address;
-	}
-
-	/*
-	 * Address changed. We can release the original endpoint, thus
-	 * allowing other to access the default address.
-	 */
-	unregister_control_endpoint_on_default_address(&hc_conn);
-
-	/*
-	 * Time to register the new endpoint.
-	 */
-	rc = usb_pipe_register(&ctrl_pipe, 0, &hc_conn);
-	if (rc != EOK) {
-		goto leave_release_free_address;
-	}
+		goto leave_stop_session;
+	}
+
+	usb_pipe_end_session(&ctrl_pipe);
+
+	/*
+	 * Register the control endpoint for the new device.
+	 */
+	rc = usb_pipe_register(&ctrl_pipe, 0, connection);
+	if (rc != EOK) {
+		rc = EREFUSED;
+		goto leave_unregister_endpoint;
+	}
+
+	/*
+	 * Release the original endpoint.
+	 */
+	unregister_control_endpoint_on_default_address(connection);
+
+	/*
+	 * Once the address is changed, we can return the default address.
+	 */
+	usb_hc_release_default_address(connection);
+
 
 	/*
@@ -289,4 +316,6 @@
 	}
 
+
+
 	/*
 	 * And now inform the host controller about the handle.
@@ -296,5 +325,5 @@
 		.handle = child_handle
 	};
-	rc = usb_hc_register_device(&hc_conn, &new_device);
+	rc = usb_hc_register_device(connection, &new_device);
 	if (rc != EOK) {
 		rc = EDESTADDRREQ;
@@ -320,11 +349,16 @@
 	 * Completely ignoring errors here.
 	 */
+
+leave_stop_session:
+	usb_pipe_end_session(&ctrl_pipe);
+
+leave_unregister_endpoint:
+	usb_pipe_unregister(&ctrl_pipe, connection);
+
 leave_release_default_address:
-	usb_pipe_unregister(&ctrl_pipe, &hc_conn);
+	usb_hc_release_default_address(connection);
 
 leave_release_free_address:
-	usb_hc_unregister_device(&hc_conn, dev_addr);
-
-	usb_hc_connection_close(&hc_conn);
+	usb_hc_unregister_device(connection, dev_addr);
 
 	return rc;
Index: uspace/lib/usb/src/pipes.c
===================================================================
--- uspace/lib/usb/src/pipes.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/src/pipes.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -41,5 +41,4 @@
 #include <errno.h>
 #include <assert.h>
-#include "pipepriv.h"
 
 #define IPC_AGAIN_DELAY (1000 * 2) /* 2ms */
@@ -242,7 +241,4 @@
  * necessary.
  *
- * @deprecated
- * Obsoleted with introduction of usb_pipe_start_long_transfer
- *
  * @param pipe Endpoint pipe to start the session on.
  * @return Error code.
@@ -250,5 +246,17 @@
 int usb_pipe_start_session(usb_pipe_t *pipe)
 {
-	usb_log_warning("usb_pipe_start_session() was deprecated.\n");
+	assert(pipe);
+
+	if (usb_pipe_is_session_started(pipe)) {
+		return EBUSY;
+	}
+
+	int phone = devman_device_connect(pipe->wire->hc_handle, 0);
+	if (phone < 0) {
+		return phone;
+	}
+
+	pipe->hc_phone = phone;
+
 	return EOK;
 }
@@ -257,7 +265,4 @@
 /** Ends a session on the endpoint pipe.
  *
- * @deprecated
- * Obsoleted with introduction of usb_pipe_end_long_transfer
- *
  * @see usb_pipe_start_session
  *
@@ -267,5 +272,17 @@
 int usb_pipe_end_session(usb_pipe_t *pipe)
 {
-	usb_log_warning("usb_pipe_end_session() was deprecated.\n");
+	assert(pipe);
+
+	if (!usb_pipe_is_session_started(pipe)) {
+		return ENOENT;
+	}
+
+	int rc = async_hangup(pipe->hc_phone);
+	if (rc != EOK) {
+		return rc;
+	}
+
+	pipe->hc_phone = -1;
+
 	return EOK;
 }
@@ -281,34 +298,5 @@
 bool usb_pipe_is_session_started(usb_pipe_t *pipe)
 {
-	pipe_acquire(pipe);
-	bool started = pipe->refcount > 0;
-	pipe_release(pipe);
-	return started;
-}
-
-/** Prepare pipe for a long transfer.
- *
- * By a long transfer is mean transfer consisting of several
- * requests to the HC.
- * Calling such function is optional and it has positive effect of
- * improved performance because IPC session is initiated only once.
- *
- * @param pipe Pipe over which the transfer will happen.
- * @return Error code.
- */
-int usb_pipe_start_long_transfer(usb_pipe_t *pipe)
-{
-	return pipe_add_ref(pipe);
-}
-
-/** Terminate a long transfer on a pipe.
- *
- * @see usb_pipe_start_long_transfer
- *
- * @param pipe Pipe where to end the long transfer.
- */
-void usb_pipe_end_long_transfer(usb_pipe_t *pipe)
-{
-	pipe_drop_ref(pipe);
+	return (pipe->hc_phone >= 0);
 }
 
Index: uspace/lib/usb/src/pipesinit.c
===================================================================
--- uspace/lib/usb/src/pipesinit.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/src/pipesinit.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -356,14 +356,10 @@
 	assert(connection);
 
-	fibril_mutex_initialize(&pipe->guard);
 	pipe->wire = connection;
 	pipe->hc_phone = -1;
-	fibril_mutex_initialize(&pipe->hc_phone_mutex);
 	pipe->endpoint_no = endpoint_no;
 	pipe->transfer_type = transfer_type;
 	pipe->max_packet_size = max_packet_size;
 	pipe->direction = direction;
-	pipe->refcount = 0;
-	pipe->auto_reset_halt = false;
 
 	return EOK;
@@ -386,6 +382,4 @@
 	    0, USB_TRANSFER_CONTROL, CTRL_PIPE_MIN_PACKET_SIZE,
 	    USB_DIRECTION_BOTH);
-
-	pipe->auto_reset_halt = true;
 
 	return rc;
@@ -419,5 +413,10 @@
 	int rc;
 
-	rc = usb_pipe_start_long_transfer(pipe);
+	TRY_LOOP(failed_attempts) {
+		rc = usb_pipe_start_session(pipe);
+		if (rc == EOK) {
+			break;
+		}
+	}
 	if (rc != EOK) {
 		return rc;
@@ -440,5 +439,5 @@
 		}
 	}
-	usb_pipe_end_long_transfer(pipe);
+	usb_pipe_end_session(pipe);
 	if (rc != EOK) {
 		return rc;
@@ -462,25 +461,4 @@
     usb_hc_connection_t *hc_connection)
 {
-	return usb_pipe_register_with_speed(pipe, USB_SPEED_MAX + 1,
-	    interval, hc_connection);
-}
-
-/** Register endpoint with a speed at the host controller.
- *
- * You will rarely need to use this function because it is needed only
- * if the registered endpoint is of address 0 and there is no other way
- * to tell speed of the device at address 0.
- *
- * @param pipe Pipe to be registered.
- * @param speed Speed of the device
- *	(invalid speed means use previously specified one).
- * @param interval Polling interval.
- * @param hc_connection Connection to the host controller (must be opened).
- * @return Error code.
- */
-int usb_pipe_register_with_speed(usb_pipe_t *pipe, usb_speed_t speed,
-    unsigned int interval,
-    usb_hc_connection_t *hc_connection)
-{
 	assert(pipe);
 	assert(hc_connection);
@@ -490,15 +468,13 @@
 	}
 
-#define _PACK2(high, low) (((high) << 16) + (low))
-#define _PACK3(high, middle, low) (((((high) << 8) + (middle)) << 8) + (low))
-
-	return async_req_4_0(hc_connection->hc_phone,
+#define _PACK(high, low) ((high) * 256 + (low))
+
+	return async_req_5_0(hc_connection->hc_phone,
 	    DEV_IFACE_ID(USBHC_DEV_IFACE), IPC_M_USBHC_REGISTER_ENDPOINT,
-	    _PACK2(pipe->wire->address, pipe->endpoint_no),
-	    _PACK3(speed, pipe->transfer_type, pipe->direction),
-	    _PACK2(pipe->max_packet_size, interval));
-
-#undef _PACK2
-#undef _PACK3
+	    _PACK(pipe->wire->address, pipe->endpoint_no),
+	    _PACK(pipe->transfer_type, pipe->direction),
+	    pipe->max_packet_size, interval);
+
+#undef _PACK
 }
 
Index: uspace/lib/usb/src/pipesio.c
===================================================================
--- uspace/lib/usb/src/pipesio.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/src/pipesio.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -49,6 +49,4 @@
 #include <assert.h>
 #include <usbhc_iface.h>
-#include <usb/request.h>
-#include "pipepriv.h"
 
 /** Request an in transfer, no checking of input parameters.
@@ -80,16 +78,13 @@
 	}
 
-	/* Ensure serialization over the phone. */
-	pipe_start_transaction(pipe);
-
 	/*
 	 * Make call identifying target USB device and type of transfer.
 	 */
-	aid_t opening_request = async_send_3(pipe->hc_phone,
+	aid_t opening_request = async_send_4(pipe->hc_phone,
 	    DEV_IFACE_ID(USBHC_DEV_IFACE), ipc_method,
 	    pipe->wire->address, pipe->endpoint_no,
+	    pipe->max_packet_size,
 	    NULL);
 	if (opening_request == 0) {
-		pipe_end_transaction(pipe);
 		return ENOMEM;
 	}
@@ -101,10 +96,4 @@
 	aid_t data_request = async_data_read(pipe->hc_phone, buffer, size,
 	    &data_request_call);
-
-	/*
-	 * Since now on, someone else might access the backing phone
-	 * without breaking the transfer IPC protocol.
-	 */
-	pipe_end_transaction(pipe);
 
 	if (data_request == 0) {
@@ -157,5 +146,5 @@
 
 	if (buffer == NULL) {
-		return EINVAL;
+			return EINVAL;
 	}
 
@@ -164,4 +153,8 @@
 	}
 
+	if (!usb_pipe_is_session_started(pipe)) {
+		return EBADF;
+	}
+
 	if (pipe->direction != USB_DIRECTION_IN) {
 		return EBADF;
@@ -172,17 +165,8 @@
 	}
 
+	size_t act_size = 0;
 	int rc;
-	rc = pipe_add_ref(pipe);
-	if (rc != EOK) {
-		return rc;
-	}
-
-
-	size_t act_size = 0;
 
 	rc = usb_pipe_read_no_checks(pipe, buffer, size, &act_size);
-
-	pipe_drop_ref(pipe);
-
 	if (rc != EOK) {
 		return rc;
@@ -226,16 +210,13 @@
 	}
 
-	/* Ensure serialization over the phone. */
-	pipe_start_transaction(pipe);
-
 	/*
 	 * Make call identifying target USB device and type of transfer.
 	 */
-	aid_t opening_request = async_send_3(pipe->hc_phone,
+	aid_t opening_request = async_send_4(pipe->hc_phone,
 	    DEV_IFACE_ID(USBHC_DEV_IFACE), ipc_method,
 	    pipe->wire->address, pipe->endpoint_no,
+	    pipe->max_packet_size,
 	    NULL);
 	if (opening_request == 0) {
-		pipe_end_transaction(pipe);
 		return ENOMEM;
 	}
@@ -245,11 +226,4 @@
 	 */
 	int rc = async_data_write_start(pipe->hc_phone, buffer, size);
-
-	/*
-	 * Since now on, someone else might access the backing phone
-	 * without breaking the transfer IPC protocol.
-	 */
-	pipe_end_transaction(pipe);
-
 	if (rc != EOK) {
 		async_wait_for(opening_request, NULL);
@@ -286,4 +260,8 @@
 	}
 
+	if (!usb_pipe_is_session_started(pipe)) {
+		return EBADF;
+	}
+
 	if (pipe->direction != USB_DIRECTION_OUT) {
 		return EBADF;
@@ -294,35 +272,7 @@
 	}
 
-	int rc;
-
-	rc = pipe_add_ref(pipe);
-	if (rc != EOK) {
-		return rc;
-	}
-
-	rc = usb_pipe_write_no_check(pipe, buffer, size);
-
-	pipe_drop_ref(pipe);
+	int rc = usb_pipe_write_no_check(pipe, buffer, size);
 
 	return rc;
-}
-
-/** Try to clear endpoint halt of default control pipe.
- *
- * @param pipe Pipe for control endpoint zero.
- */
-static void clear_self_endpoint_halt(usb_pipe_t *pipe)
-{
-	assert(pipe != NULL);
-
-	if (!pipe->auto_reset_halt || (pipe->endpoint_no != 0)) {
-		return;
-	}
-
-
-	/* Prevent indefinite recursion. */
-	pipe->auto_reset_halt = false;
-	usb_request_clear_endpoint_halt(pipe, 0);
-	pipe->auto_reset_halt = true;
 }
 
@@ -343,13 +293,11 @@
     void *data_buffer, size_t data_buffer_size, size_t *data_transfered_size)
 {
-	/* Ensure serialization over the phone. */
-	pipe_start_transaction(pipe);
-
 	/*
 	 * Make call identifying target USB device and control transfer type.
 	 */
-	aid_t opening_request = async_send_3(pipe->hc_phone,
+	aid_t opening_request = async_send_4(pipe->hc_phone,
 	    DEV_IFACE_ID(USBHC_DEV_IFACE), IPC_M_USBHC_CONTROL_READ,
 	    pipe->wire->address, pipe->endpoint_no,
+	    pipe->max_packet_size,
 	    NULL);
 	if (opening_request == 0) {
@@ -363,5 +311,4 @@
 	    setup_buffer, setup_buffer_size);
 	if (rc != EOK) {
-		pipe_end_transaction(pipe);
 		async_wait_for(opening_request, NULL);
 		return rc;
@@ -375,12 +322,4 @@
 	    data_buffer, data_buffer_size,
 	    &data_request_call);
-
-	/*
-	 * Since now on, someone else might access the backing phone
-	 * without breaking the transfer IPC protocol.
-	 */
-	pipe_end_transaction(pipe);
-
-
 	if (data_request == 0) {
 		async_wait_for(opening_request, NULL);
@@ -440,4 +379,8 @@
 	}
 
+	if (!usb_pipe_is_session_started(pipe)) {
+		return EBADF;
+	}
+
 	if ((pipe->direction != USB_DIRECTION_BOTH)
 	    || (pipe->transfer_type != USB_TRANSFER_CONTROL)) {
@@ -445,21 +388,8 @@
 	}
 
-	int rc;
-
-	rc = pipe_add_ref(pipe);
-	if (rc != EOK) {
-		return rc;
-	}
-
 	size_t act_size = 0;
-	rc = usb_pipe_control_read_no_check(pipe,
+	int rc = usb_pipe_control_read_no_check(pipe,
 	    setup_buffer, setup_buffer_size,
 	    data_buffer, data_buffer_size, &act_size);
-
-	if (rc == ESTALL) {
-		clear_self_endpoint_halt(pipe);
-	}
-
-	pipe_drop_ref(pipe);
 
 	if (rc != EOK) {
@@ -488,17 +418,14 @@
     void *data_buffer, size_t data_buffer_size)
 {
-	/* Ensure serialization over the phone. */
-	pipe_start_transaction(pipe);
-
 	/*
 	 * Make call identifying target USB device and control transfer type.
 	 */
-	aid_t opening_request = async_send_4(pipe->hc_phone,
+	aid_t opening_request = async_send_5(pipe->hc_phone,
 	    DEV_IFACE_ID(USBHC_DEV_IFACE), IPC_M_USBHC_CONTROL_WRITE,
 	    pipe->wire->address, pipe->endpoint_no,
 	    data_buffer_size,
+	    pipe->max_packet_size,
 	    NULL);
 	if (opening_request == 0) {
-		pipe_end_transaction(pipe);
 		return ENOMEM;
 	}
@@ -510,5 +437,4 @@
 	    setup_buffer, setup_buffer_size);
 	if (rc != EOK) {
-		pipe_end_transaction(pipe);
 		async_wait_for(opening_request, NULL);
 		return rc;
@@ -521,15 +447,8 @@
 		rc = async_data_write_start(pipe->hc_phone,
 		    data_buffer, data_buffer_size);
-
-		/* All data sent, pipe can be released. */
-		pipe_end_transaction(pipe);
-
 		if (rc != EOK) {
 			async_wait_for(opening_request, NULL);
 			return rc;
 		}
-	} else {
-		/* No data to send, we can release the pipe for others. */
-		pipe_end_transaction(pipe);
 	}
 
@@ -572,4 +491,8 @@
 	}
 
+	if (!usb_pipe_is_session_started(pipe)) {
+		return EBADF;
+	}
+
 	if ((pipe->direction != USB_DIRECTION_BOTH)
 	    || (pipe->transfer_type != USB_TRANSFER_CONTROL)) {
@@ -577,19 +500,6 @@
 	}
 
-	int rc;
-
-	rc = pipe_add_ref(pipe);
-	if (rc != EOK) {
-		return rc;
-	}
-
-	rc = usb_pipe_control_write_no_check(pipe,
+	int rc = usb_pipe_control_write_no_check(pipe,
 	    setup_buffer, setup_buffer_size, data_buffer, data_buffer_size);
-
-	if (rc == ESTALL) {
-		clear_self_endpoint_halt(pipe);
-	}
-
-	pipe_drop_ref(pipe);
 
 	return rc;
Index: uspace/lib/usb/src/recognise.c
===================================================================
--- uspace/lib/usb/src/recognise.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/src/recognise.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -404,5 +404,15 @@
 	child->driver_data = dev_data;
 
+	rc = usb_pipe_start_session(&ctrl_pipe);
+	if (rc != EOK) {
+		goto failure;
+	}
+
 	rc = usb_device_create_match_ids(&ctrl_pipe, &child->match_ids);
+	if (rc != EOK) {
+		goto failure;
+	}
+
+	rc = usb_pipe_end_session(&ctrl_pipe);
 	if (rc != EOK) {
 		goto failure;
Index: uspace/lib/usb/src/request.c
===================================================================
--- uspace/lib/usb/src/request.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/src/request.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -871,18 +871,4 @@
 }
 
-/** Clear halt bit of an endpoint pipe (after pipe stall).
- *
- * @param pipe Control pipe.
- * @param ep_index Endpoint index (in native endianness).
- * @return Error code.
- */
-int usb_request_clear_endpoint_halt(usb_pipe_t *pipe, uint16_t ep_index)
-{
-	return usb_request_clear_feature(pipe,
-	    USB_REQUEST_TYPE_STANDARD, USB_REQUEST_RECIPIENT_ENDPOINT,
-	    uint16_host2usb(USB_FEATURE_SELECTOR_ENDPOINT_HALT),
-	    uint16_host2usb(ep_index));
-}
-
 /**
  * @}
Index: uspace/srv/bd/ata_bd/ata_bd.c
===================================================================
--- uspace/srv/bd/ata_bd/ata_bd.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/srv/bd/ata_bd/ata_bd.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -372,5 +372,4 @@
 	uint16_t w;
 	uint8_t c;
-	uint16_t bc;
 	size_t pos, len;
 	int rc;
@@ -388,24 +387,11 @@
 	} else if (rc == EIO) {
 		/*
-		 * There is something, but not a register device. Check to see
-		 * whether the IDENTIFY command left the packet signature in
-		 * the registers in case this is a packet device.
-		 *
-		 * According to the ATA specification, the LBA low and
-		 * interrupt reason registers should be set to 0x01. However,
-		 * there are many devices that do not follow this and only set
-		 * the byte count registers. So, only check these.
+		 * There is something, but not a register device.
+		 * It could be a packet device.
 		 */
-		bc = ((uint16_t)pio_read_8(&cmd->cylinder_high) << 8) |
-		    pio_read_8(&cmd->cylinder_low);
-
-		if (bc == PDEV_SIGNATURE_BC) {
-			rc = identify_pkt_dev(disk_id, &idata);
-			if (rc == EOK) {
-				/* We have a packet device. */
-				d->dev_type = ata_pkt_dev;
-			} else {
-				return EIO;
-			}
+		rc = identify_pkt_dev(disk_id, &idata);
+		if (rc == EOK) {
+			/* We have a packet device. */
+			d->dev_type = ata_pkt_dev;
 		} else {
 			/* Nope. Something's there, but not recognized. */
@@ -417,4 +403,5 @@
 	}
 
+	printf("device caps: 0x%04x\n", idata.caps);
 	if (d->dev_type == ata_pkt_dev) {
 		/* Packet device */
@@ -579,9 +566,8 @@
 
 	/*
-	 * Do not wait for DRDY to be set in case this is a packet device.
-	 * We determine whether the device is present by waiting for DRQ to be
-	 * set after issuing the command.
+	 * This is where we would most likely expect a non-existing device to
+	 * show up by not setting SR_DRDY.
 	 */
-	if (wait_status(0, ~SR_BSY, NULL, TIMEOUT_PROBE) != EOK)
+	if (wait_status(SR_DRDY, ~SR_BSY, NULL, TIMEOUT_PROBE) != EOK)
 		return ETIMEOUT;
 
@@ -591,20 +577,15 @@
 		return ETIMEOUT;
 
-	/*
-	 * If ERR is set, this may be a packet device, so return EIO to cause
-	 * the caller to check for one.
-	 */
+	/* Read data from the disk buffer. */
+
+	if ((status & SR_DRQ) != 0) {
+		for (i = 0; i < identify_data_size / 2; i++) {
+			data = pio_read_16(&cmd->data_port);
+			((uint16_t *) buf)[i] = data;
+		}
+	}
+
 	if ((status & SR_ERR) != 0) {
 		return EIO;
-	}
-
-	if (wait_status(SR_DRQ, ~SR_BSY, &status, TIMEOUT_PROBE) != EOK)
-		return ETIMEOUT;
-
-	/* Read data from the disk buffer. */
-
-	for (i = 0; i < identify_data_size / 2; i++) {
-		data = pio_read_16(&cmd->data_port);
-		((uint16_t *) buf)[i] = data;
 	}
 
Index: uspace/srv/bd/ata_bd/ata_hw.h
===================================================================
--- uspace/srv/bd/ata_bd/ata_hw.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/srv/bd/ata_bd/ata_hw.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -293,12 +293,4 @@
 };
 
-enum ata_pdev_signature {
-	/**
-	 * Signature put by a packet device in byte count register
-	 * in response to Identify command.
-	 */
-	PDEV_SIGNATURE_BC	= 0xEB14
-};
-
 #endif
 
Index: uspace/srv/devman/devman.c
===================================================================
--- uspace/srv/devman/devman.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/srv/devman/devman.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -555,4 +555,17 @@
 }
 
+/** Remember the driver's phone.
+ *
+ * @param driver	The driver.
+ * @param phone		The phone to the driver.
+ */
+void set_driver_phone(driver_t *driver, sysarg_t phone)
+{
+	fibril_mutex_lock(&driver->driver_mutex);
+	assert(driver->state == DRIVER_STARTING);
+	driver->phone = phone;
+	fibril_mutex_unlock(&driver->driver_mutex);
+}
+
 /** Notify driver about the devices to which it was assigned.
  *
@@ -672,5 +685,4 @@
 	list_initialize(&drv->devices);
 	fibril_mutex_initialize(&drv->driver_mutex);
-	drv->phone = -1;
 }
 
Index: uspace/srv/devman/devman.h
===================================================================
--- uspace/srv/devman/devman.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/srv/devman/devman.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -88,5 +88,5 @@
 	
 	/** Phone asociated with this driver. */
-	int phone;
+	sysarg_t phone;
 	/** Name of the device driver. */
 	char *name;
@@ -316,4 +316,5 @@
 
 extern driver_t *find_driver(driver_list_t *, const char *);
+extern void set_driver_phone(driver_t *, sysarg_t);
 extern void initialize_running_driver(driver_t *, dev_tree_t *);
 
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/srv/devman/main.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -95,4 +95,5 @@
 	/* Find driver structure. */
 	driver = find_driver(&drivers_list, drv_name);
+	
 	if (driver == NULL) {
 		log_msg(LVL_ERROR, "No driver named `%s' was found.", drv_name);
@@ -106,30 +107,4 @@
 	drv_name = NULL;
 	
-	fibril_mutex_lock(&driver->driver_mutex);
-	
-	if (driver->phone >= 0) {
-		/* We already have a connection to the driver. */
-		log_msg(LVL_ERROR, "Driver '%s' already started.\n",
-		    driver->name);
-		fibril_mutex_unlock(&driver->driver_mutex);
-		async_answer_0(iid, EEXISTS);
-		return NULL;
-	}
-	
-	switch (driver->state) {
-	case DRIVER_NOT_STARTED:
-		/* Somebody started the driver manually. */
-		log_msg(LVL_NOTE, "Driver '%s' started manually.\n",
-		    driver->name);
-		driver->state = DRIVER_STARTING;
-		break;
-	case DRIVER_STARTING:
-		/* The expected case */
-		break;
-	case DRIVER_RUNNING:
-		/* Should not happen since we do not have a connected phone */
-		assert(false);
-	}
-	
 	/* Create connection to the driver. */
 	log_msg(LVL_DEBUG, "Creating connection to the `%s' driver.",
@@ -138,5 +113,4 @@
 	ipc_callid_t callid = async_get_call(&call);
 	if (IPC_GET_IMETHOD(call) != IPC_M_CONNECT_TO_ME) {
-		fibril_mutex_unlock(&driver->driver_mutex);
 		async_answer_0(callid, ENOTSUP);
 		async_answer_0(iid, ENOTSUP);
@@ -145,7 +119,5 @@
 	
 	/* Remember driver's phone. */
-	driver->phone = IPC_GET_ARG5(call);
-	
-	fibril_mutex_unlock(&driver->driver_mutex);
+	set_driver_phone(driver, IPC_GET_ARG5(call));
 	
 	log_msg(LVL_NOTE, 
@@ -607,5 +579,5 @@
 		method = DRIVER_CLIENT;
 	
-	if (driver->phone < 0) {
+	if (driver->phone <= 0) {
 		log_msg(LVL_ERROR, 
 		    "Could not forward to driver `%s' (phone is %d).",
@@ -647,5 +619,5 @@
 	dev = fun->dev;
 	
-	if (dev->state != DEVICE_USABLE || dev->drv->phone < 0) {
+	if (dev->state != DEVICE_USABLE || dev->drv->phone <= 0) {
 		async_answer_0(iid, EINVAL);
 		return;
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/srv/fs/fat/fat_ops.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -722,6 +722,6 @@
 		    (str_cmp((char *) d->name, FAT_NAME_DOT)) == 0) {
 			memset(d, 0, sizeof(fat_dentry_t));
-			memcpy(d->name, FAT_NAME_DOT, FAT_NAME_LEN);
-			memcpy(d->ext, FAT_EXT_PAD, FAT_EXT_LEN);
+			str_cpy((char *) d->name, 8, FAT_NAME_DOT);
+			str_cpy((char *) d->ext, 3, FAT_EXT_PAD);
 			d->attr = FAT_ATTR_SUBDIR;
 			d->firstc = host2uint16_t_le(childp->firstc);
@@ -732,6 +732,6 @@
 		    (str_cmp((char *) d->name, FAT_NAME_DOT_DOT) == 0)) {
 			memset(d, 0, sizeof(fat_dentry_t));
-			memcpy(d->name, FAT_NAME_DOT_DOT, FAT_NAME_LEN);
-			memcpy(d->ext, FAT_EXT_PAD, FAT_EXT_LEN);
+			str_cpy((char *) d->name, 8, FAT_NAME_DOT_DOT);
+			str_cpy((char *) d->ext, 3, FAT_EXT_PAD);
 			d->attr = FAT_ATTR_SUBDIR;
 			d->firstc = (parentp->firstc == FAT_CLST_ROOT) ?
